HDU 2639 背包第k优解

Posted LuZhiyuan

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了HDU 2639 背包第k优解相关的知识,希望对你有一定的参考价值。

Bone Collector II

Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4824    Accepted Submission(s): 2514


Problem Description
The title of this problem is familiar,isn‘t it?yeah,if you had took part in the "Rookie Cup" competition,you must have seem this title.If you haven‘t seen it before,it doesn‘t matter,I will give you a link:

Here is the link:http://acm.hdu.edu.cn/showproblem.php?pid=2602

Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.

If the total number of different values is less than K,just ouput 0.
 

 

Input
The first line contain a integer T , the number of cases.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
 

 

Output
One integer per line representing the K-th maximum of the total value (this number will be less than 231).
 

 

Sample Input
3
5 10 2
1 2 3 4 5
5 4 3 2 1
5 10 12
1 2 3 4 5
5 4 3 2 1
5 10 16
1 2 3 4 5
5 4 3 2 1
 

 

Sample Output
12
2
0
 

 

Author
teddy
 
Source
 题意:
有n件物品,每件物品有价值和体积,有容量为m的背包,求能够得到的第k大的价值
代码:
//以前的dp[V]数组再加一维dp[V]K]表示V状态时第k大的值,当枚举到第i个物品时
//dp[i][V]=max(dp[i-1][V],dp[i-1][V-v]),当前状态由两个状态转移来的所以前k大的值
//也是由两个状态的前k大的值转移来的。注意本体价值重复的算一个。
#include<iostream>
#include<cstdio>
#include<cstring>
using namespace std;
const int MAXN=109;
const int MAXV=1009;
const int MAXK=39;
int dp[MAXV][MAXK];
int val[MAXN],vol[MAXN];
int N,V,K;
int main()
{
    int t;
    scanf("%d",&t);
    while(t--){
        scanf("%d%d%d",&N,&V,&K);
        for(int i=1;i<=N;i++) 
            scanf("%d",&val[i]);
        for(int i=1;i<=N;i++)
            scanf("%d",&vol[i]);
        memset(dp,0,sizeof(dp));
        for(int i=1;i<=N;i++){
            for(int j=V;j>=vol[i];j--){
                int a1=1,a2=1,p1[39],p2[39];
                for(int c=1;c<=K;c++){
                    p1[c]=dp[j][c];
                    p2[c]=dp[j-vol[i]][c]+val[i];
                }
                p1[K+1]=p2[K+1]=-1;
                int c=0;
                while(c!=K){
                    int tmp=max(p1[a1],p2[a2]);
                    if(tmp==p1[a1]){
                        a1++;
                        if(tmp!=dp[j][c]) dp[j][++c]=tmp;
                        else if(tmp==0) dp[j][++c]=0;
                    }
                    else if(tmp==p2[a2]){
                        a2++;
                        if(tmp!=dp[j][c]) dp[j][++c]=tmp;
                        else if(tmp==0) dp[j][++c]=0;
                    }
                }
                //cout<<i<<" "<<j<<endl;
                //for(int k=1;k<=K;k++) cout<<dp[j][k]<<" ";
                //cout<<endl;
            }
        }
        printf("%d\n",dp[V][K]);
    }
    return 0;
}

 

 

以上是关于HDU 2639 背包第k优解的主要内容,如果未能解决你的问题,请参考以下文章

hdu2639 01背包第K优解

HDU 2639 Bone Collector II(01背包变形第K大最优解)

背包专题A - Bone Collector II hdu2639 01背包的第k个最优解

HDU 2639 01背包(分解)

第k优解 hdu 2639

HDU2639(01背包第K大)